#ifndef DfDifferedCall_H_
#define DfDifferedCall_H_

#include <uOsCnst.h>
/*    pStOriginRamStt
 *              
 *      RAM m_ppStInterrRAM m_ppStInterr
 *                                      
 *                    ROM                     ROM       
 *                                                      
 *                                                    
 *                              
 */

#ifndef Df78K4_
struct StDifferedCall{
    void (*m_pfDifferedFunctionCall)(void);
    const struct StDifferedCall** m_ppStDffrdNext;
};
#elif defined(Df78K4_)
typedef struct StDifferedCall** TyppStDifferedCall;
struct StDifferedCall{
    void (*m_pfDifferedFunctionCall)(void);
    TyppStDifferedCall m_ppStDffrdNext;
};
#endif

void Dffrd_link(const struct StDifferedCall* pStAg);

#endif /* DfDifferedCall_H_ */


/*---------------------------- OOP code genaration ------------------------*/

#ifdef dfGnrtDfcCdInvlvFnctn

#define dfStDifferedCallBff_(x) stDifferedCall_##x_
#define dfStDifferedCallN_(x) dfStDifferedCallBff_(x)
#define dfStDifferedCall_ dfStDifferedCallN_(dfN)

#define dfStDifferedCallRomBff_(x) stDifferedCallRom_##x_
#define dfStDifferedCallRomN_(x) dfStDifferedCallRomBff_(x)
#define dfStDifferedCallRom_ dfStDifferedCallRomN_(dfN)

static const struct StDifferedCall* dfStDifferedCall_;
static const struct StDifferedCall dfStDifferedCallRom_ ={
         dfGnrtDfcCdInvlvFnctn
        ,&dfStDifferedCall_
    };

/* dfRequestDfcStt() ͊荞݃[`̒甭słB
 */
#define dfRequestDfcStt() Dffrd_link(&dfStDifferedCallRom_)
#endif /* dfGnrtDfcCdInvlvFnctn */

