#include <FrmCntxt.h>

extern void CntxtCue_loadTaskParameter(const struct StGroupVTable* cpStVTableAg, void** ppInPrmAg);
extern void CntxtCue_restoreTaskParameter(const struct StGroupVTable* cpStVTableAg, void** ppVdPrmAg);
extern void TaskBase_setDelay(struct StTaskBase* pStTaskBaseAg, enum EnmTaskState enAg, TyWord wdDelayAg);

struct StFrameContext** FrmCntxt_ppStExecutingTcbRmStt; /* TskCntxt.c QƂ */
#define dfPpStCntxt ((struct StFrameContext**)(FrmCntxt_ppStExecutingTcbRmStt))
/* EnLoopPolling 
 *     ( (*((int*)pStStateDelayAt) & 0xf000) != ( EnLoopPolling * 0x1000 ) )
 * ł΁AEnLoopPolling Ԃ̂܂ EnRun_ ɂɎs
 */
static void return2Task( struct StFrameContext* pStFrameContextAg)
{
    int inReturnValueAt;

    inReturnValueAt = pStFrameContextAg->m_stTaskBase.m_enTaskState;

    /* m_blReady==1 ł΁A(pStFrameContextAg) & 0xf000 == EnLoopPolling<<12 ɂȂȂ*/
    if ( (*((int*)pStFrameContextAg) & 0xf000) == ( EnLoopingWait_ * 0x1000 ) ){
        *(int*)pStFrameContextAg = 
                (*((int*)pStFrameContextAg) & 0xfff ) | ((EnLoopRun_ * 0x1000) & 0xf000);
        assert( pStFrameContextAg->m_stTaskBase.m_enTaskState == EnLoopRun_);
    }else{
        *(int*)pStFrameContextAg = 
                (*((int*)pStFrameContextAg) & 0xfff ) | ((EnRun_ * 0x1000) & 0xf000);
        assert( pStFrameContextAg->m_stTaskBase.m_enTaskState == EnRun_);
    }

#ifdef DfVC_
    __asm{
        mov eax, dword ptr [pStFrameContextAg]
        mov ebx, dword ptr [eax+0ch]        // [eax+8h] == m_inEBX
        mov esi, dword ptr [eax+10h]       //          == m_inESI
        mov edi, dword ptr [eax+14h]       //          == m_inEDI
        
        // SP = &pStFrameContextAg - m_ppStCntxt_sp  (12)
        lea ecx, DWORD PTR pStFrameContextAg
        sub ecx, dword ptr [eax+8]        // [eax+4] == m_ppStCntxt_sp
        // PcCntxt_xxxx( struct StDelayPcContext** ppStFrameContextAg) Ă񂾌 
        //     call PcCntxt_xxxx(TyWord)
        //     add esp,8
        // ƂĂB4 ́A̕  stack ̒̓RpCɍs킹
        // ̂ꂪłۏ؂ȂłBRpCEIvV
        // version ɂĕς\
        mov esp, ecx

        // return Ŕׂ悤stIntrCntxt.m_pTimeUpAddress X^bNɐݒ肷
        mov ecx, dword ptr [eax+4]          // [eax] == m_pTimeUpAddress
        push ecx
        mov eax, dword ptr [inReturnValueAt]
        ret
    }
#elif defined(Df78K4_)
#asm
    ; ̎OgƁARUN Ԃ̂Ƃ 3 ԂĂ܂ movw bc,rp3 gׂB
    ;shrw    ax,7       ; ax = ax >> 12 <-- 
    ;shrw    ax,5
    ;movw bc,ax         ; pStFrameContextAg->m_enTaskState:߂l̐ݒ 

    movw bc,rp3         ; rp3==inReturnValueAt

    ; uup  FrmCntxt_ppStExecutingTcbRmStt ̒lێĂ
    movw ax,[up+5]      ; whl == m_ppStCntxt_sp
    subw ax,#9          ;  9 byte(߂AhX rp3,vp,up) X^bNςݏグĂ

    movg whl,sp
    subw hl,ax
    movg sp,whl         ; sp == &pVdPrmAt - offset

    movw ax,up          ; pStFrameContextAg X^bNɐݒ肷
    movw [sp+0],ax

    movg whl,[uup+2]
    push whl            ; set time up address
    ret
#endasm
#endif  /* DfVC_ */
}


/* ̊֐ Task Stack, Frame context ł XXX_execute(.) łg*/
void FrmCntxt_execute(const struct StGroupVTable* cpStVTableAg)
{

    assert ( cpStVTableAg->m_pStTaskBase->m_blReady == true );

    /*  == true ꂽ̂͂܂ȂłB true łȂƂ
     * ^XNs邱Ƃ̓Rs[^̖\ɈNł
     */
    if (cpStVTableAg->m_pStTaskBase->m_blReady == true){
#ifdef DfVC_
        //
        void* pVdArDamieAt[4];
        volatile enum EnmTaskState enAt;
        FrmCntxt_ppStExecutingTcbRmStt = ((struct StFrameContext**)pVdArDamieAt) - 1;
        //void* pVdArDamieAt[4];
        //volatile enum EnmTaskState enAt;
        //FrmCntxt_ppStExecutingTcbRmStt = ((struct StFrameContext**)pVdArDamieAt)-1;
#elif defined(Df78K4_)
        volatile enum EnmTaskState enAt;
        struct StFrameContext* pStFrameContextAt;
        void* pVdArDamieAt[4];

        /* pStFrameContextAt X^bN̕ϐɂ */
        pVdArDamieAt[0] = &pStFrameContextAt;
        pStFrameContextAt = (struct StFrmCntxt*)cpStVTableAg->m_pStTaskBase;
        FrmCntxt_ppStExecutingTcbRmStt = &pStFrameContextAt;
#endif
        /* 荞ݓ^XNƂ FrmCntxt_ppStExecutingTcbRmStt  push
         * KvBInterruptContext_execute(.) ʂɍ
         */
        /* pVdDamieAt ^XN֐ pVdPrmAg ̈ʒuɋIɍ킹*/
        CntxtCue_loadTaskParameter(cpStVTableAg, pVdArDamieAt);

        enAt = (enum EnmTaskState)cpStVTableAg->m_pStTaskBase->m_enTaskState;

        /* VC  switch gƃX^bNɔrlu */
        if ( enAt == EnStart_){
            /*void* pVdDamieAt;*/
            /* ꖽ EnRun_ ԂƃfB[l 0  */
            *(int*)(cpStVTableAg->m_pStTaskBase) = EnRun_ * 0x1000;
            if ( cpStVTableAg->m_pByTaskStackBottom != 0){
                ((struct StStckFrmContext*)(cpStVTableAg->m_pStTaskBase))->m_pByStack
                        = (unsigned char*)cpStVTableAg->m_pByTaskStackBottom;
            }
            ((struct StFrameContext*)(cpStVTableAg->m_pStTaskBase))->m_pTimeUpAddress(
                    (struct StFrameContext*)(cpStVTableAg->m_pStTaskBase) ); 
            /* ֐|C^ m_pTimeUpAddress ͈ŌĂ
             * m_pTimeUpAddress  void*  pVdDamieAt łB
             */
        }else if ( (enAt == EnTimeup_) || (enAt == EnRestart_) ){
            /* *(int*)pStStateDelayAt = (EnRun_ * 0x1000) & 0x7000; ͌ōs
             * pStStateDelayAt->m_enTaskState ɂ return value 
             *  return2Task(.) ŏ邽 EnRun_ ̐ݒ͂łȂ
             */
            return2Task( (struct StFrameContext*)(cpStVTableAg->m_pStTaskBase) );
        }

        enAt = (enum EnmTaskState)cpStVTableAg->m_pStTaskBase->m_enTaskState;
        if ( (enAt == EnRun_) || (enAt == EnLoopRun_) ){
             *(int*)(cpStVTableAg->m_pStTaskBase) = EnDormant_*0x1000;
        }
        CntxtCue_restoreTaskParameter(cpStVTableAg, pVdArDamieAt);
    }
}


void FrmCntxt_executeTaskLoop(const struct StGroupVTable* cpStVTableAg)
{
    struct StTaskBase* pStTaskBaseAt;

    /* m_blReady==true Ȃ΁ATask Loop ͎sȂ*/
    pStTaskBaseAt = cpStVTableAg->m_pStTaskBase;
    assert(pStTaskBaseAt->m_blReady == false);

    /* m_blReady == 1 Ȃ Loop Polling sȂ */
    /* restart Ȃǂ LoopingCue ɌqĂĂ EnLoopPolling ł͂Ȃ */
    if ( (( *(int*)pStTaskBaseAt) & 0xf000 )== (EnLoopingWait_ * 0x1000) ){
#ifdef DfVC_
        void* pVdArDamieAt[4];
        volatile enum EnmTaskState enAt;
        FrmCntxt_ppStExecutingTcbRmStt = (struct StFrameContext**)(pVdArDamieAt - 1);
#elif defined(Df78K4_)
        volatile enum EnmTaskState enAt;
        struct StFrameContext* pStFrameContextAt;
        void* pVdArDamieAt[4];

        /* pStFrameContextAt X^bN̕ϐɂ */
        pVdArDamieAt[0] = &pStFrameContextAt;
        pStFrameContextAt = (struct StFrmCntxt*)cpStVTableAg->m_pStTaskBase;
        FrmCntxt_ppStExecutingTcbRmStt = &pStFrameContextAt;
#endif
        /* 荞ݓ^XNƂ FrmCntxt_ppStExecutingTcbRmStt  push
         * KvBInterruptContext_execute(.) ʂɍ
         */
        CntxtCue_loadTaskParameter(cpStVTableAg, pVdArDamieAt);
        /*cpStVTableAg->m_pStTaskBase->m_enTaskState = EnLoopRun_;*/
        return2Task( (struct StFrameContext*)(cpStVTableAg->m_pStTaskBase) );
        /*---------------- after context switch ----------------*/
        enAt = (enum EnmTaskState)cpStVTableAg->m_pStTaskBase->m_enTaskState;
        if ( (enAt == EnRun_) || (enAt == EnLoopRun_) ){
             *(int*)(cpStVTableAg->m_pStTaskBase) = EnDormant_*0x1000;
        }
        CntxtCue_restoreTaskParameter(cpStVTableAg, pVdArDamieAt);
    }
}


void FrmCntxt_saveContext(
        int inStackFrameOffsetAg
        , void(*pfReturnAddAg)(struct StFrameContext*) )
{
    (*dfPpStCntxt)->m_pTimeUpAddress = pfReturnAddAg;
    (*dfPpStCntxt)->m_ppStCntxt_sp = inStackFrameOffsetAg;
#ifdef DfVC_
    // ebp == [PcCntxt_ppStExecutingCntxt - 12]
    __asm{
        mov       eax,dword ptr [FrmCntxt_ppStExecutingTcbRmStt]// eax == StFrameContext*
        mov       dword ptr [eax+0ch],ebx        // m_inEBX = ebx
        mov       dword ptr [eax+10h],esi        // m_inESI = esi
        mov       dword ptr [eax+14h],edi        // m_inEDI = edi
    }
#elif defined(Df78K4_)
    /* 78K4 ̂Ƃ pfReturnAddAg, inStackFrameOffsetAg ̑ɏKvƂȂ */
#endif
}

static void return2Os(void)
{
#ifdef DfVC_
    // MSC5.0/6.0 ł PcCntxt_ppVdExecutingPrmStt - 8 ̈ʒuɖ߂AhX
    // PcCntxt_ppVdExecutingPrmStt - 12 ̈ʒuɁAOS  ebp 
    __asm{
        mov       eax,dword ptr [FrmCntxt_ppStExecutingTcbRmStt]
        mov ebp,[eax - 8]
        sub eax,4
        mov esp,eax
        ret    
    }
#elif defined(Df78K4_)
#asm
        subg whl,whl
        movw hl,!_FrmCntxt_ppStExecutingTcbRmStt
        subw hl,#11          ; X^bN &pVdDamiAt  11 oCgɖ߂AhX
        movg sp,whl         ; sp == &pVdPrmAt - 3
        ret;
#endasm
#endif
}

DfPascal enum EnmTaskState FrmCntxt_wait(TyWord wdDelayAg)
{
    assert((wdDelayAg/DfTickUnit_) <= 0xfff);
    assert( ( (*dfPpStCntxt)->m_stTaskBase.m_enTaskState == EnRun_)
         || ( (*dfPpStCntxt)->m_stTaskBase.m_enTaskState == EnLoopRun_)
    );

#ifdef DfVC_
    FrmCntxt_saveContext(
        /* FrmCntxt_wait(.) ĂяoO sp ̒l pVdArDamieAt Ƃ̍*/
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&wdDelayAg) /* sp - pStIntCntxt refferecn*/
        ,(void(*)( struct StFrameContext*))*((&wdDelayAg) - 1 ) /* return address */
    );
#elif defined(Df78K4_)
    FrmCntxt_saveContext(
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&wdDelayAg) -5 /* sp - pVdArDamieAt + 4*/
        ,*(void(**)( struct StFrameContext*))(((TyByte*)(&wdDelayAg)) - 3 ) /* return address */
    );
#endif
    TaskBase_setDelay( (struct StTaskBase*)(*dfPpStCntxt), EnWait_, wdDelayAg);
    return2Os();
    return (enum EnmTaskState)0;   /* damie return */
}

DfPascal enum EnmTaskState FrmCntxt_doTaskPolling(TyWord wdDelayAg)
{
    assert( (wdDelayAg/DfTickUnit_) <= 0xfff);
    assert( ( (*dfPpStCntxt)->m_stTaskBase.m_enTaskState == EnRun_)
         || ( (*dfPpStCntxt)->m_stTaskBase.m_enTaskState == EnLoopRun_)
    );

    if ( (*dfPpStCntxt)->m_stTaskBase.m_enTaskState == EnLoopRun_ ){
        extern TyWord TaskBase_whatDelay( struct StTaskBase* pStAg);
        wdDelayAg = TaskBase_whatDelay( (struct StTaskBase*)(*dfPpStCntxt));
    }
#ifdef DfVC_
    FrmCntxt_saveContext(
        /* FrmCntxt_wait(.) ĂяoO sp ̒l pVdArDamieAt Ƃ̍*/
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&wdDelayAg) /* sp - pVdArDamieAt + 4*/
        ,(void(*)( struct StFrameContext*))*((&wdDelayAg) - 1 ) /* return address */
    );
#elif defined(Df78K4_)
    FrmCntxt_saveContext(
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&wdDelayAg) -5 /* sp - pVdArDamieAt + 4*/
        ,*(void(**)( struct StFrameContext*))(((TyByte*)(&wdDelayAg)) - 3 ) /* return address */
    );
#endif
    TaskBase_setDelay( (struct StTaskBase*)(*dfPpStCntxt), EnLoopingWait_, wdDelayAg);
    return2Os();
    return (enum EnmTaskState)0;   /* damie return */
}

DfPascal int FrmCntxt_run( void(*pfAg)(struct StFrameContext* ) )
{
    /*CntxtGrp_pStExecutingCntxtGlb->m_stFrameContext.m_pTimeUpAddress = pfAg;*/
    /* mov edx(esp),ebp, mov ebp, [edx] JԂƂŁA߂ */

#ifdef DfVC_
    __asm{
        mov edx,dword ptr[pfAg]
        mov eax,dword ptr [FrmCntxt_ppStExecutingTcbRmStt]
        sub eax,8
        mov esp,eax
        mov ebp,[eax]
        mov [eax],edx
        ret
    }
#elif defined( Df78K4_ )
#asm
    ; ӃX^bŇݒl菬AhXɃf[^ݒ肵Ȃ
    ; whl  pfAg ̒lĂ
    movg tde,whl    ; tde  pfAg ڂBwhl oR sp ̐ݒs߂
    subg whl,whl
    movw hl,!_FrmCntxt_ppStExecutingTcbRmStt
    subg whl,#11
    movg sp,whl
    push tde
    ; ^XÑvg^Cv taskFunc(struct StTaskBase*, void*) ̌`ł
    movw hl,!_FrmCntxt_ppStExecutingTcbRmStt
    movw ax,[hl]   ; ax == StTaskBase*
    ret
#endasm
#endif  /* DfVC_ */
    return 0;   /* damie 0 to avoid errro */
}




/*--------------------- Task Stack Frame Ɋ֘AĎg֐ --------------*/
#undef dfPpStCntxt
#define dfPpStCntxt ((struct StStckFrmContext**)(FrmCntxt_ppStExecutingTcbRmStt))
/* TCB X^bNɎcƂ StkCntxt_call() łȂB  ֐
 * inArDammieAt[] ̐ݒ̓AvP[Vɍ킹āA[U[s
 */
DfPascal int FrmCntxt_call(int (*pfAg)(struct StStckFrmContext* ) )
{
#ifdef DfVC_
    extern void FrmCntxt_saveContext(
        int inStackFrameOffsetAg
        , void(*pfReturnAddAg)(struct StFrameContext*) );
#endif

    struct StStckFrmContext*  pStStckFrmContextAt;

    (*dfPpStCntxt)->m_pByStack -= (sizeof( struct StStckFrmContext));

    pStStckFrmContextAt = (struct StStckFrmContext*)((*dfPpStCntxt)->m_pByStack);

#ifdef DfVC_
    FrmCntxt_saveContext(
        /* TskCntxt_call(.) ĂяoO sp ̒l pVdArDamieAt Ƃ̍*/
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&pfAg) /* sp - pVdArDamieAt + 4*/
        ,(void(*)( struct StFrameContext*))*((&pfAg) - 1 ) /* return address */
    );
    *pStStckFrmContextAt = **dfPpStCntxt;
    //(*pStStckFrmContextAt) = (**pStCntxtAg);
    __asm{
        mov edx,dword ptr[pfAg]
        mov eax,dword ptr [FrmCntxt_ppStExecutingTcbRmStt]
        sub eax,8
        mov esp,eax
        mov ebp,[eax]
        mov [eax],edx   /* pfAg ĂяoȌԂɂ */
        ret
    }
#elif defined( Df78K4_ )
    /* coding lefted 00.09.01 */
    FrmCntxt_saveContext(
         (int)FrmCntxt_ppStExecutingTcbRmStt -  (int)(&pfAg) -7 /* sp - pVdArDamieAt + 4*/
        /* ߂AhX 5 = pfAg:3 byte + pStStckFrmContextAt:2byte*/
        ,(void(*)( struct StStckFrmContext*))
                *(void(*)())( ((TyByte*)&pfAg)+5)
    );
    TaskBase_setDelay( (struct StTaskBase*)(*dfPpStCntxt), EnRun_, 0);
    *pStStckFrmContextAt = **dfPpStCntxt;
    /* coding lefted   ppVdExecutingPrmSttApStExecutingCntxtGlb gĂȂ*/
#asm
    ; ӃX^bŇݒl菬AhXɃf[^ݒ肵Ȃ
    ; [sp+0]  pfAg ̒lĂ
    movg    whl,[sp+0]  ; pfAg
    movg tde,whl    ; tde  pfAg ڂBwhl oR sp ̐ݒs߂
    subg whl,whl
    movw hl,!!_FrmCntxt_ppStExecutingTcbRmStt
    subw hl,#13 ; 13  pVdPrmAt[4]+ return address + pTcbRamAg
    push tde
    movw hl,!_FrmCntxt_ppStExecutingTcbRmStt
    movw ax,[hl]
    ret
#endasm
#endif
    return 0;   /* damie return */
}

DfPascal void FrmCntxt_push( void* pVdAg)
{
    (*dfPpStCntxt)->m_pByStack -= sizeof( pVdAg );
    *(void**)((*dfPpStCntxt)->m_pByStack) = pVdAg;
}

/* StkCntxt_pop(.) ĝ StStackAndContext* l݂̂łBł StStackAndContext**
 * ŌĂяoقA^XN ROM ȂȂ
 */
DfPascal void FrmCntxt_pop( void** ppVdAg)
{
    *ppVdAg = *(void**) ((*dfPpStCntxt)->m_pByStack);

    (*dfPpStCntxt)->m_pByStack -= sizeof( *ppVdAg );
}

/* dfReturnVoid()  TskCntxt_returnWithValue(0) Ōp */
DfPascal void FrmCntxt_returnWithValue(int inRetValueAg)
{
    struct StStckFrmContext*  pStStckFrmContextAt;
    pStStckFrmContextAt = (struct StStckFrmContext*)((*dfPpStCntxt)->m_pByStack);
    (*dfPpStCntxt)->m_pByStack += (sizeof( struct StStckFrmContext));
    **dfPpStCntxt = *pStStckFrmContextAt;
#ifdef DfVC_
    /*return address  common  stack ɖ߂ */
    /*(((int*)ppStAg) - 1) = (int)pStStckFrmContextAt->m_pTimeUpAddress;*/
    __asm{
        mov       eax,dword ptr [FrmCntxt_ppStExecutingTcbRmStt]
        mov       eax, [eax]
        mov       ebx, dword ptr [eax+0ch]        // ebx = m_inEBX
        mov       esi, dword ptr [eax+10h]        // esi = m_inESI
        mov       edi, dword ptr [eax+14h]        // edi = m_inEDI
        

        mov ecx, dword ptr [FrmCntxt_ppStExecutingTcbRmStt]    // ecx ɂ͖߂^XN ebp 
        sub ecx, dword ptr [eax+8]          // m_inSP_pVdArDamieAt Ė߂Ƃ SP
        // ŏ 8  ppStCntxtAg  bp ʒu܂ł̍B
        // ^񒆂 4  ret ߂X^bN炷 4 byte ł
        // Ō 4  StkCntxt_call(.) ̎ add sp,8 镪̕␳ł
        //sub  ecx, 8 + 4 + 8         
        // Ăяõ^XNɖ߂邽߂̃AhXlX^bNݒ肷
        mov esp,ecx

        // edx ɂ pStStckFrmContextAt->m_pTimeUpAddress 
        mov edx, [eax+4]
        push edx // edx ɂ pStStckFrmContextAt->m_pTimeUpAddress Ă

        mov eax, dword ptr[inRetValueAg]// ߂l

        // *FrmCntxt_ppStExecutingTcbRmStt ɍ킹 ebp ̐ݒ
        mov ecx, dword ptr [FrmCntxt_ppStExecutingTcbRmStt] // ecx ɂ͖߂^XN ebp 
        sub ecx,8   // bp  FrmCntxt_ppStExecutingTcbRmStt  8 oCgȂAhXwĂ
        mov ebp, ecx

        ret // return to Task
    }
#elif defined( Df78K4_ )
    /*pStStckFrmContextAt->m_pByStackFrame = 3;*/
    /* coding lefted 00.11.10 */
    /*inRetValueAg++; */
    /*  incw    rp3*/
#asm    
        ; up  pStStckFrmContextAt Ă 
        subg whl, whl
        movw hl,!!_FrmCntxt_ppStExecutingTcbRmStt
        movw ax,[up+5]  ;pStStckFrmContextAt->m_ppStCntxt_sp
        subw hl,ax
        movg sp,whl     ; sp  ^XNĂяoÖʒuɖ߂
        
        movg whl,[up+2] ; whl = m_pTimeUpAddress
        push whl        
        
        movw hl,!_FrmCntxt_ppStExecutingTcbRmStt
        subw hl,#13     ; 13  pVdPrmAt[4]+ return address + pTcbRamAg
        ; ߂l ax ɓ͂B movw [hl],up ߂Ȃ
        ;movw [hl],up    ; ^XN pTcbRamAt ݒ肵
                        ; Œł^XN̍ŏ push up sĂB
                        ; pTcbRamAg ̐ݒŃ^XNւ̃AhX邱Ƃ͂ȂB
        movw ax,up
        movw [hl],ax

        mov bc,rp3      ; set return value
        ret
#endasm
#endif  /* DfVC_ */
}


