#ifndef DfFrameContxt_H_
#define DfFrameContxt_H_
#include <CntxtCue.h>
#include <TaskBase.h>

typedef void(*TyPfTimeUpAddress)( struct StFrameContext*);
struct StFrameContext {
    struct StTaskBase m_stTaskBase;
    void (*m_pTimeUpAddress)( struct StFrameContext*);
#ifdef DfVC_
    /* VC task context*/
    int m_ppStCntxt_sp;
    int m_inEBX;
    int m_inESI;
    int m_inEDI;
#elif defined DfGcc_
    /* coding lefted for gcc*/
    int m_ppStCntxt_sp;
    int m_inEBX;
    int m_inESI;
    int m_inEDI;
#elif defined(Df78K4_)
    int m_ppStCntxt_sp;
#endif

};

struct StStckFrmContext{
    struct StTaskBase m_stTaskBase;
    void (*m_pTimeUpAddress)( struct StFrameContext*);
#ifdef DfVC_
    /* VC task context */
    int m_ppStCntxt_sp;
    int m_inEBX;
    int m_inESI;
    int m_inEDI;
#elif defined(Df78K4_)
    int m_ppStCntxt_sp;
#endif
    /* ̏܂ł StFrameContext Ɠ*/

    /* Stack ɂ integer alignment @킪B*/
    /* m_pByStack ̏lݒ肷ƂA alignment lݒ肷*/
    unsigned char*      m_pByStack;
    /* ^XNEX^bNEt[̏l StGroupVTable.m_pByTaskStackBottom 
     * 
     */
};

void FrmCntxt_execute(const struct StGroupVTable* cpStVTableAg);
void FrmCntxt_executeTaskLoop(const struct StGroupVTable* cpStVTableAg);
void FrmCntxt_returnWithValue(int inRetValueAg);
enum EnmTaskState FrmCntxt_wait(TyWord wdDelayAg);
int FrmCntxt_call(int (*pfAg)(struct StStckFrmContext* ) );
#endif /* DfFrameContxt_H_ */

