#ifndef DfCntxtCue_H_
#define DfCntxtCue_H_

#include <common.h>
#include <TaskBase.h>

/* TCB Group 𐧌䂷Ƃ̃f[^E֐Z߂BS ROM ϐƂ
 * CX^XB̂ Next StGroupVTable pointer |C^
 * |C^ɂKvoĂ܂BRAM ̏邽߂ɔRXgłB
 */
// typedef TyCppStGroupVTable ɂȂ NEC RpCG[ɂȂ
//  typedef  const ܂߂ NEC compiier  error ɂȂ̂ŕ
typedef void(*TyPfCnstStGroupVTable)(const struct StGroupVTable*);
typedef const struct StGroupVTable** TyCppStGroupVTable;

#ifndef Df78K4_
struct StGroupVTable{
    struct StTaskBase* m_pStTaskBase;
    /* Redy Cue  Front ɃvbV^XN͗D揇ʂ̍ʂȃ^XNł */
    TyPfCnstStGroupVTable m_pfPushFrntBk;
    /* m_pfExecute() ̓^XNEp[^𐧌䂷̂ StGroupVTable* KvɂȂ */
    TyPfCnstStGroupVTable m_pfExecute;

    /* ̉ TmupCntxt.h/.c ł͎gȂ*/
    TyPfCnstStGroupVTable m_pfLooping;

    TyCppStGroupVTable m_ppStGroupVTableNext;
    TyCppStGroupVTable m_ppStGroupLoopingNext;

    /* ȉ̓AvP[VɂĕςĂB*/
    void** m_ppVdPrm;
    TyByte  m_byPrmArSize; /* p[^zTCY */

    /* Stack ɂ integer alignment @킪B*/
    /* m_pByStack ̏lݒ肷ƂA alignment lݒ肷*/
    unsigned char* m_pByTaskStackBottom;   /*^XNEX^bN Frame Context Ŏg */
    /* EnStart_ ̂Ƃ TskCntxt_execute(.) ̂ȂŃ^XNEX^bN̏s*/
};
#elif defined(Df78K4_)
/*typedef void(*TyPfCnstStGroupVTable)(const struct StGroupVTable*); const ƃG[ɂȂ*/
typedef void(*TyPfCnstStGroupVTable)( struct StGroupVTable*);
typedef struct StGroupVTable** TyppStGroupVTable;

struct StGroupVTable{
    struct StTaskBase* m_pStTaskBase;
    /* Redy Cue  Front ɃvbV^XN͗D揇ʂ̍ʂȃ^XNł */
    TyPfCnstStGroupVTable m_pfPushFrntBk;
    /* m_pfExecute() ̓^XNEp[^𐧌䂷̂ StGroupVTable* KvɂȂ */
    TyPfCnstStGroupVTable m_pfExecute;

    /* ̉ TmupCntxt.h/.c ł͎gȂ*/
    TyPfCnstStGroupVTable m_pfLooping;

    const TyppStGroupVTable m_ppStGroupVTableNext;
    const TyppStGroupVTable m_ppStGroupLoopingNext;

    /* ȉ̓AvP[VɂĕςĂB*/
    void** m_ppVdPrm;
    TyByte  m_byPrmArSize; /* p[^zTCY */

    /* Stack ɂ integer alignment @킪B*/
    /* m_pByStack ̏lݒ肷ƂA alignment lݒ肷*/
    unsigned char* m_pByTaskStackBottom;   /*^XNEX^bN Frame Context Ŏg */
    /* EnStart_ ̂Ƃ TskCntxt_execute(.) ̂ȂŃ^XNEX^bN̏s*/
};

#endif

void ReadyCue_pushBack( const struct StGroupVTable* cpStGroupVTableAg);
void ReadyCue_pushFront( const struct StGroupVTable* cpStGroupVTableAg);
void DelayCue_pushFront( const struct StGroupVTable* cpStGroupVTableAg);
void ReadyCue_start( const struct StGroupVTable* cpStGroupVTableAg);
void DelayCue_erase( const struct StGroupVTable* cpStGroupVTableAg);

void TaskBase_restart(const struct StGroupVTable* cpStGroupVTableAg);
#endif /* DfCntxtCue_H_ */
