#ifndef Df_DynamicPolling_H_
#define Df_DynamicPolling_H_
#include <common.h>     /* DfBool g common.h  include */
#include <uOsCnst.h>
#include <CntxtCue.h>


/*     pStOriginRamStt
 *               
 *       RAM m_ppStNext  RAM m_ppStNext  
 *         m_pfPolling     m_pfPolling   
 *                     ROM                     ROM       
 *                               
 */

struct StDynmcPllng{
    DfBool (*m_pfPolling)(void);
    const struct StDynmcPllng** m_ppStNextDynmcPllng;
    const struct StGroupVTable* m_pStGroupVTable;
};

void DynmcPll_link(const struct StDynmcPllng* pStDynmcPllngAg);

#endif /*Df_DynamicPolling_H_*/


/*---------------------------- OOP code genaration ------------------------*/
#ifdef dfGnrtDynPllngCdInvlvFnctn

/* Dynamic Polling, Differed Funciton ̂悤ɁAƗĂA܂sĎg
 * }N undef ́Aꂼ OOP header file ōs܂B OOP
 * header file ̗FD͈͂A܂ȂłB
 */
#undef dfStDynmcPllngRamBff_
#undef dfStDynmcPllngRamN_
#undef dfStDynmcPllngRam_

#undef dfStDynmcPllngRomBff_
#undef dfStDynmcPllngRomN_
#undef dfStDynmcPllngRom_


#define dfStDynmcPllngRamBff_(x) stDynmcPllngRam_##x_
#define dfStDynmcPllngRamN_(x) dfStDynmcPllngRamBff_(x)
#define dfStDynmcPllngRam_ dfStDynmcPllngRamN_(dfN_)

#define dfStDynmcPllngRomBff_(x) stDynmcPllngRom_##x_
#define dfStDynmcPllngRomN_(x) dfStDynmcPllngRomBff_(x)
#define dfStDynmcPllngRom_ dfStDynmcPllngRomN_(dfN_)


static const struct StDynmcPllng* dfStDynmcPllngRam_;

#ifdef DfTaskOOP_H_
// DynPlOOP.h is included after including TaskOOP.h
static const struct StDynmcPllng dfStDynmcPllngRom_ ={
         dfGnrtDynPllngCdInvlvFnctn
        ,&dfStDynmcPllngRam_
        ,&dfCstVTableStt_
    };
#else
static const struct StDynmcPllng dfStDynmcPllngRom_ ={
         dfGnrtDynPllngCdInvlvFnctn
        ,&dfStDynmcPllngRam_
        ,0
    };
#endif  //DfTaskOOP_H_

#define dfDynmcPllngLnk() DynmcPll_link(&dfStDynmcPllngRom_)

#endif /* dfGnrtDynPllngCdInvlvFnctn */

