#include <DynPlOOP.h>

/*     pStOriginRamStt
 *               
 *       RAM m_ppStNext  RAM m_ppStNext  
 *                                       
 *                     ROM                     ROM       
 *                               
 */

static const struct StDynmcPllng* cpStOriginRamStt =(struct StDynmcPllng*) dfEndOfList;

void DynmcPll_link(const struct StDynmcPllng* pStDynmcPllngAg)
{
#if 1
    assert( int(*(pStDynmcPllngAg->m_ppStNextDynmcPllng)) <= dfEndOfList);

    if ( (int)*(pStDynmcPllngAg->m_ppStNextDynmcPllng) <= dfEndOfList){
        if ( ((unsigned int) cpStOriginRamStt) <= dfUnlinked ){
            *(pStDynmcPllngAg->m_ppStNextDynmcPllng)
                    = (const struct StDynmcPllng*)dfEndOfList;
            pStDynmcPllngAg = pStDynmcPllngAg;
        }else{
            *(pStDynmcPllngAg->m_ppStNextDynmcPllng)
                    = cpStOriginRamStt;
            cpStOriginRamStt = pStDynmcPllngAg;
        }
    }
#else
    assert( int(*(pStDynmcPllngAg->m_ppStNextDynmcPllng)) < dfEndOfList);

    if ( *(pStDynmcPllngAg->m_ppStNextDynmcPllng) == dfUnlinked){
        if ( unsigned int(cpStOriginRamStt) <= dfEndOfList ){
            *(pStDynmcPllngAg->m_ppStNextDynmcPllng)
                    = (const struct StDynmcPllng*)dfEndOfList;
            pStDynmcPllngAg = pStDynmcPllngAg;
        }else{
            *(pStDynmcPllngAg->m_ppStNextDynmcPllng)
                    = cpStOriginRamStt;
            cpStOriginRamStt = pStDynmcPllngAg;
        }
    }
#endif
}

void DynmcPll_execute(void)
{
    static const struct StDynmcPllng* cpStDynmcPllngAt;
    static const struct StDynmcPllng** cppStNextAt;

    for ( cppStNextAt = &cpStOriginRamStt
        ; (unsigned int)*cppStNextAt > dfEndOfList
        ; cppStNextAt = cpStDynmcPllngAt->m_ppStNextDynmcPllng
    ){
        cpStDynmcPllngAt = *cppStNextAt;
        if ( (   cpStDynmcPllngAt->m_pStGroupVTable 
              && cpStDynmcPllngAt->m_pStGroupVTable->m_pStTaskBase->m_blReady
             )
         || !cpStDynmcPllngAt->m_pfPolling()
        ){
            /* m_pfPolling()  false Ԃ̂ŁAXgO */
            *cppStNextAt = *(cpStDynmcPllngAt->m_ppStNextDynmcPllng);
            *(cpStDynmcPllngAt->m_ppStNextDynmcPllng) = dfUnlinked;
        }
    }
}
