#include <CntxtCue.h>
#include <FllOOP.h>

extern void TaskBase_setDelay(struct StTaskBase* pStTaskBaseAg, enum EnmTaskState enAg, TyWord wdDelayAg);

/* X^eBbNȋʕϐ jmpOsStt ĝ FllCntxt_execute ̓J[Vu
 * łȂȂB荞݃[`ĂяoȂBłÂ悤ȏdRe
 * LXgEXCb`荞݂ĂяoƂׂ͔łB
 */
static jmp_buf jmpOsStt;
struct StFullContext* pStFullContextStt; /* s^XN TCB w */

void FllCntxt_execute(const struct StGroupVTable* cpStVTableAg)
{
    struct StFullContext* pStFullContextAt;

    pStFullContextAt = (struct StFullContext*)(cpStVTableAg->m_pStTaskBase);
    assert( pStFullContextAt->m_stTaskBase.m_blReady == true );

    /*  == true ꂽ̂͂܂ȂłB true łȂƂ
     * ^XNs邱Ƃ̓Rs[^̖\ɈNł
     */
    if (pStFullContextAt->m_stTaskBase.m_blReady == true){
        if ( !setjmp(jmpOsStt) ){
            pStFullContextStt = pStFullContextAt;
            switch ( pStFullContextAt->m_stTaskBase.m_enTaskState){
            case EnStart_:{
                void *pVdAt;
                
                if ( cpStVTableAg->m_ppVdPrm != 0){
                    pVdAt = *(cpStVTableAg->m_ppVdPrm);
                }

                *(int*)(pStFullContextAt) = EnRun_ * 0x1000;
#ifdef DfVC_
                // ̃u[X̒̓RpCˑł
                // task() ĂяoƓɃX^bN؂ւ܂
                // start R}hɂ m_jmpTask[EnEip] ɂ̓^XNJn
                // AhXݒ肳Ă
                int inSpAt;             // stack pointer
                inSpAt = (int)(cpStVTableAg->m_pByTaskStackBottom);
                //sizeof(pStFullContextAt->m_inAr)
                //       + /*sp address*/((int)pStFullContextAt->m_inAr);
                _asm{
                    mov eax,[inSpAt]
                    mov esp,eax

                    mov eax, [pVdAt]    //^XN֐ pVdPrm ς
                    push eax

                    mov eax, [pStFullContextAt]    //^XN֐ StFullContext* ς
                    push eax

                    lea eax, $comeAtTaskEnd // ^XN return Ŗ߂AhXݒ
                    push eax
                    
                    mov eax, dword ptr [pStFullContextAt]
                    mov eax,[eax+18h]   // 18h  EnEip ܂ł̃ItZbg
                    jmp eax
                  
                  $comeAtTaskEnd:  // ^XN return ߂Ŗ߂Ă
                    // m_jmpTask.Registration  fs:[0] ݒ肵
                    // unwind Ȃ
                    // application task  context switch  setjmp/longjmp g
                    // ̂ŁȂ΍􂪕KvƂȂ
                    mov eax, DWORD PTR [pStFullContextAt]
                    add eax, 4                 ; 00000004H offset for m_setjmp
                    mov ecx, fs:[0]
                    mov dword ptr[eax+0x18],ecx; 0x18 indicate EnRegistration
                }
                longjmp( jmpOsStt, true); 
#endif
            }
            case EnTimeup_:
            case EnRestart_:
                *(int*)(pStFullContextAt) 
                    = EnRun_ * 0x1000 + (*(int*)(pStFullContextAt) & 0xfff);
#ifdef DfVC_
                _asm{
                    // m_jmpTask.Registration  fs:[0] ݒ肵
                    // unwind Ȃ
                    // application task  context switch  setjmp/longjmp g
                    // ̂ŁȂ΍􂪕KvƂȂ
                    mov eax, DWORD PTR [pStFullContextAt]
                    add eax, 4                 ; 0000004H offset for m_setjmp
                    mov ecx, fs:[0]
                    mov dword ptr[eax+0x18],ecx; 0x18 indicate EnRegistration
                }
                longjmp( pStFullContextAt->m_jmpTask, EnLoopRun_); 
#endif
            }
            /*---------------- after context switch ----------------*/
            switch ( pStFullContextAt->m_stTaskBase.m_enTaskState){
            case EnRun_:
            case EnLoopRun_:
                *(int*)(pStFullContextAt) = EnDormant_*0x1000;
            }
        }
        pStFullContextStt = 0;
    }
}

void FllCntxt_executeTaskLoop(const struct StGroupVTable* cpStVTableAg)
{
    struct StFullContext* pStFullContextAt;

    /* m_blReady==true Ȃ΁ATask Loop ͎sȂ */
    pStFullContextAt = (struct StFullContext*)(cpStVTableAg->m_pStTaskBase);
    assert ( pStFullContextAt->m_stTaskBase.m_blReady == true );

    /* m_blReady == 1 Ȃ Loop Polling sȂ */
    /* restart Ȃǂ LoopingCue ɌqĂĂ EnLoopPolling ł͂Ȃ */
    if ( (( *(int*)pStFullContextAt) & 0xf000 )== (EnLoopingWait_ * 0x1000) ){
        if ( !setjmp(jmpOsStt) ){
            if ( cpStVTableAg->m_ppVdPrm != 0){
                pStFullContextStt = pStFullContextAt;
            }
#ifdef DfVC_
            _asm{
                /* m_jmpTask.Registration  fs:[0] ݒ肵
                 * unwind Ȃ
                 * application task  context switch  setjmp/longjmp g
                 * ̂ŁȂ΍􂪕KvƂȂ
                 */
                mov eax, DWORD PTR [pStFullContextAt]
                add eax, 4                 ; 0000004H offset for m_setjmp
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx; 0x18 indicate EnRegistration
            }
            longjmp( pStFullContextAt->m_jmpTask, EnLoopRun_); 
#endif
        }
        /*---------------- after context switch ----------------*/
        switch ( pStFullContextAt->m_stTaskBase.m_enTaskState){
        case EnRun_:
        case EnLoopRun_:
             *(int*)(pStFullContextAt) = EnDormant_*0x1000;
        }
        pStFullContextStt = 0;
    }
}


/* eax  jmpOsStt address 邽߂Ɏg֐*/
static int* getJmpOsStt(void){ return (int*)jmpOsStt;}
enum EnmTaskState FllCntxt_wait( TyWord wdDelayAg)
{
    enum EnmTaskState enAt;

    assert((wdDelayAg/DfTickUnit_) <= 0xfff);
    assert(pStFullContextStt != 0);
    assert( ( (pStFullContextStt)->m_stTaskBase.m_enTaskState == EnRun_)
         || ( (pStFullContextStt)->m_stTaskBase.m_enTaskState == EnLoopRun_)
    );

    TaskBase_setDelay( (struct StTaskBase*)pStFullContextStt, EnWait_, wdDelayAg);
    enAt = (enum EnmTaskState)setjmp(pStFullContextStt->m_jmpTask);
    if (!enAt){
#ifdef DfVC_
        getJmpOsStt();  // ߂l eax  jmpOsStt 
            // jmpOsStt.Registration  fs:[0] ݒ肵
            // unwind Ȃ
            // application task  context switch  setjmp/longjmp g
            // ̂ŁȂ΍􂪕KvƂȂ
            __asm{
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx // 0x18 == EnRegistration * 4
            }
#endif  /* DfVC_ */
        longjmp(jmpOsStt,1);
    }
    return enAt;
}

enum EnmTaskState FllCntxt_doTaskPolling( TyWord wdDelayAg)
{
    enum EnmTaskState enAt;

    assert((wdDelayAg/DfTickUnit_) <= 0xfff);
    assert(pStFullContextStt != 0);
    assert( ( (pStFullContextStt)->m_stTaskBase.m_enTaskState == EnRun_)
         || ( (pStFullContextStt)->m_stTaskBase.m_enTaskState == EnLoopRun_)
    );

    if ( (pStFullContextStt)->m_stTaskBase.m_enTaskState == EnLoopRun_ ){
        extern TyWord TaskBase_whatDelay( struct StTaskBase* pStAg);
        wdDelayAg = TaskBase_whatDelay( (struct StTaskBase*)(pStFullContextStt));
    }
    TaskBase_setDelay( (struct StTaskBase*)pStFullContextStt, EnLoopingWait_, wdDelayAg);

    enAt = (enum EnmTaskState)setjmp(pStFullContextStt->m_jmpTask);
    if (!enAt){
#ifdef DfVC_
        getJmpOsStt();  // ߂l eax  jmpOsStt 
            // jmpOsStt.Registration  fs:[0] ݒ肵
            // unwind Ȃ
            // application task  context switch  setjmp/longjmp g
            // ̂ŁȂ΍􂪕KvƂȂ
            __asm{
                mov ecx, fs:[0]
                mov dword ptr[eax+0x18],ecx
            }
#endif  /* DfVC_ */
        longjmp(jmpOsStt,1);
    }
    return enAt;
}
