#ifndef DfPcContext_
#define DfPcContext_

#undef DfTickUnit_
#ifndef DfTickUnit_
    //STL task ɂĂ DfTickUnit  1 ȊOɂӖȂ
#   define DfTickUnit_ 1
#endif

/* StStateDelay  context switch ̎ނɊւ炸p */
#include <list>
#include <kcommon.h>

// ClPolling PƂłĝœƗ
class ClPolling{
  public:
    ClPolling(bool blAddAg=true);   // true ̂ƂɌ肵ăXgɒǉ
    static void ExecutePollingGroupStt(void);
    static void EndStt(void){ delete m_pLstpClPollingStt;}
  protected:
    virtual bool polling(void){return !m_blListed;}  // pŎ

  private:
    bool m_blListed;
    static std::list<ClPolling*>* m_pLstpClPollingStt;
  protected:
    void addToList(void);
    void eraseFromList(void){ m_blListed = false;}
    static std::list<ClPolling*>& getPollingListStt(void);
};

class ClTaskBase : public ClPolling{
  public:
    enum EnmTaskState { // 
             EnDormant=0
            // wait() ̖߂l m_enTaskState ̂̂̒lԂ
            //EnDefaulWait
            ,EnWait // Time up  Restart ʂ
            ,EnLoopingWait
            ,EnTimeup=3
            ,EnStart =4
            // Wait or EnLoopingWait ɑ΂AX^[g𔭍s EnRestart ɂȂ
            ,EnRestart
            , EnRun = 6
            , EnLoopRun
            //,EnDormant Ԃ m_blReady == false, m_inDelay==0
            // ɂȂB m_blReady,m_inDelay ̃NA͒x\
            // Cue OꂽƂɃNA邩łB
    };
    enum EnmTaskState  m_enTaskState;
    //one chip k-uOS ł͎ start @\ EnStart Ԃɂ邱ƂŎ
    ClTaskBase( bool blLinkPollingAg=false, bool blStartFirstAg=false);
    virtual void Start( void ); 

  protected:
    virtual void task(void){assert(0);} // pĎ^XN{̊֐
    virtual void restart(void );
    // m_inDelay=0 ɂ̂ Delay Cue OƂ
    void terminate(void);

    virtual bool isDefaultWait(void){ return m_enTaskState == EnWait;}
    virtual bool isTerminated(void){ return m_enTaskState == EnDormant;}
  
    virtual EnmTaskState doTaskPolling(int inDelayAg){assert(0); return EnDormant;}
    virtual EnmTaskState wait(int inDelayAg=EnInfinite){assert(0);return EnDormant;}
    virtual void execute(void){assert(0);}
    virtual void executeTaskLoop(void){assert(0);}

    bool m_blReady;

  private:
    int inDamie;    // assembler code ł m_BP_SP offset  28==0x1c ɍ킹
//------------ Delay Beigin --------------
  protected:
    int m_inDelay;

    bool decrement(void);   // ʂ 0 ɂȂ true Ԃ
    void setDelay(int inAg);     // list  push ̂ m_inDelay==0 ̂Ƃ
  public:
    enum { EnInfinite=0};
    int WhatDelayTime(void){ return m_inDelay;}
//------------ Delay End --------------

//------------  Groupt  Beigin --------------
  public:
    static void DecrementDelayCueStt(void);
    static void EndStt();
    static void ExecuteReadyCueStt(void);
  protected:
    static void executeLoopingCueStt(void);

  private:
    static std::list<ClTaskBase*>* m_pLstpDelayCueStt;
    static std::list<ClTaskBase*>* m_pLstpReadyCueStt;
    static std::list<ClTaskBase*>* m_pLstpLoopingCueStt;
  protected:
    // static ɐIuWFNg̃RXgN^ addToXXXCue() 
    // ĂяoƂł STL list 삷悤ɉ̍׍H
    static std::list<ClTaskBase*>& getDelayCueStt(void);
    static std::list<ClTaskBase*>& getReadyCueStt(void);
    static std::list<ClTaskBase*>& getLoopingCueStt(void);

    //p addToReadyCue() Apush_front gėDs邱Ƃ
    //łBSTL task ŁA܂ł邱Ƃ͏Ȃ̂ŎȂB
    //one chip k-uOS ł͗D悵Ďs^XN̂ push_front 
    void addToReadyCue(void);
    void addToLoopingCue(void);
//------------  Groupt  End --------------
};



class ClTimeup : public ClTaskBase{
    // virtual bool execute(void); pĎ
  protected:
    virtual void execute(void);
  public:
    ClTimeup(bool blLinkPollingAg=false, bool blStartAg=false)
            : ClTaskBase( blLinkPollingAg, blStartAg){}
    
    void StartWithDelay(int inDelayAg){ m_enTaskState = EnWait; setDelay(inDelayAg);}
};



class ClStkFrmCntxt : public ClTaskBase{
  public:
    ClStkFrmCntxt(bool blLinkPollingAg=false, int inStackSizeAg=10, bool blStartAg=false);
  private:
    struct StStackFrame{
        int m_inTimeUpAddress;
        // VC task context
        int m_BP_SP;
        int m_inEBX;
        int m_inESI;
        int m_inEDI;
    
        // immediateStart(.) immeidiateReturn2Task(.) ̂ 
        // m_ppStackFrame o[X^eBbNɂłȂAȂB
    }m_stStackFrame;
    ClStkFrmCntxt** m_ppClStkFrmCntxt;    // stack frame ʒu this ̃AhX
    void return2Task(void);
    void return2LoopTask(void);
  protected:
    virtual EnmTaskState doTaskPolling(int inDelayAg);
    virtual EnmTaskState wait(int inDelayAg=EnInfinite);
    virtual void execute(void);
    virtual void executeTaskLoop(void);

// Stack control belogned to each Task --- begin
  private:
    //int m_inReturnVal;
    int m_inReturnAddress;
    ClStkFrmCntxt* m_pClStkFrmCntxt;
  protected:
    int call(int(ClStkFrmCntxt::*pf)(void));
    void returnFromTaskSub(int inReturnValAg=0);
  public:
// Stack control belogned to each Task --- end


};




#   include <setjmp.h>
#ifndef dfStackSize
#   define dfStackSize 500  // 80 ȉł͔
#endif

#define dfStlBreakLooping() m_enTaskState = EnRun; break

class ClFullCntxt : public ClTaskBase{
    enum En86Reg { EnEbp, EnEbx, EnEdi, EnEsi, EnEsp, EnEip, EnRegistration,
        EnTryLevel, EnCokkie,  EnUnwindFunc, EnUnwindData0 };
    static jmp_buf m_jmpOsStt;
    jmp_buf m_jmpTask;
    int m_inAr[dfStackSize];
    int* getJmpOsStt(void){ return m_jmpOsStt;} // eax  m_jmpOsStt address 
  protected:
    virtual EnmTaskState loopingWait(int inDelayAg);
    virtual EnmTaskState wait(int inDelayAg=EnInfinite);
    virtual void execute(void);
    virtual void executeTaskLoop(void);
};

#endif //DfPcContext_
